clang-tools 10.0.0

Classes | Public Types | Public Member Functions | List of all members
clang::tidy::readability::IdentifierNamingCheck Class Reference

Checks for identifiers naming style mismatch. More...

`#include <IdentifierNamingCheck.h>`

Inheritance diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]
Collaboration diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]

## Classes
struct | NamingCheckFailure
| Holds an identifier name check failure, tracking the kind of the identifier, its possible fixup and the starting locations of all the identifier usages. More...
struct | NamingStyle

## Public Types
enum | CaseType { CT_AnyCase = 0, CT_LowerCase, CT_CamelBack, CT_UpperCase, CT_CamelCase, CT_CamelSnakeCase, CT_CamelSnakeBack }
enum | ShouldFixStatus { ShouldFixStatus::ShouldFix, ShouldFixStatus::ConflictsWithKeyword, ShouldFixStatus::ConflictsWithMacroDefinition, ShouldFixStatus::IgnoreFailureThreshold, ShouldFixStatus::InsideMacro }
| This enum will be used in select of the diagnostic message. More...
typedef std::pair< SourceLocation, std::string > | NamingCheckId
typedef llvm::DenseMap< NamingCheckId, NamingCheckFailure > | NamingCheckFailureMap

## Public Member Functions
| IdentifierNamingCheck (StringRef Name, ClangTidyContext *Context)
| ~IdentifierNamingCheck ()
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | registerPPCallbacks (const SourceManager &SM, Preprocessor *PP, Preprocessor *ModuleExpanderPP) override
| Override this to register `PPCallbacks` in the preprocessor. More...
void | onEndOfTranslationUnit () override
void | checkMacro (SourceManager &sourceMgr, const Token &MacroNameTok, const MacroInfo *MI)
| Check Macros for style violations. More...
void | expandMacro (const Token &MacroNameTok, const MacroInfo *MI)
| Add a usage of a macro if it already has a violation. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
const LangOptions & | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for identifiers naming style mismatch.

This check will try to enforce coding guidelines on the identifiers naming. It supports `lower_case`, `UPPER_CASE`, `camelBack` and `CamelCase` casing and tries to convert from one to another if a mismatch is detected.

It also supports a fixed prefix and suffix that will be prepended or appended to the identifiers, regardless of the casing.

Many configuration options are available, in order to be able to create different rules for different kind of identifier. In general, the rules are falling back to a more generic rule if the specific case is not configured.

Definition at line 34 of file IdentifierNamingCheck.h.

## Member Typedef Documentation

## ◆ NamingCheckFailureMap

typedef llvm::DenseMap<NamingCheckId, NamingCheckFailure> clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailureMap

Definition at line 115 of file IdentifierNamingCheck.h.

## ◆ NamingCheckId

typedef std::pair<SourceLocation, std::string> clang::tidy::readability::IdentifierNamingCheck::NamingCheckId

Definition at line 112 of file IdentifierNamingCheck.h.

## Member Enumeration Documentation

## ◆ CaseType

enum clang::tidy::readability::IdentifierNamingCheck::CaseType

Enumerator
CT_AnyCase |
CT_LowerCase |
CT_CamelBack |
CT_UpperCase |
CT_CamelCase |
CT_CamelSnakeCase |
CT_CamelSnakeBack |

Definition at line 46 of file IdentifierNamingCheck.h.

## ◆ ShouldFixStatus

enum clang::tidy::readability::IdentifierNamingCheck::ShouldFixStatus
| strong

This enum will be used in select of the diagnostic message.

Each value below IgnoreFailureThreshold should have an error message.

Enumerator
ShouldFix |
ConflictsWithKeyword |
ConflictsWithMacroDefinition | The fixup will conflict with a language keyword, so we can't fix it automatically.
IgnoreFailureThreshold | The fixup will conflict with a macro definition, so we can't fix it automatically. Values pass this threshold will be ignored completely i.e no message, no fixup.
InsideMacro |

Definition at line 70 of file IdentifierNamingCheck.h.

## Constructor & Destructor Documentation

## ◆ IdentifierNamingCheck()

clang::tidy::readability::IdentifierNamingCheck::IdentifierNamingCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 165 of file IdentifierNamingCheck.cpp.

## ◆ ~IdentifierNamingCheck()

clang::tidy::readability::IdentifierNamingCheck::~IdentifierNamingCheck | ( |  | ) |
| default

## Member Function Documentation

## ◆ check()

void clang::tidy::readability::IdentifierNamingCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 726 of file IdentifierNamingCheck.cpp.

## ◆ checkMacro()

void clang::tidy::readability::IdentifierNamingCheck::checkMacro | ( | SourceManager & | sourceMgr,
|  | const Token & | MacroNameTok,
|  | const MacroInfo * | MI
| ) |  |

Check Macros for style violations.

Definition at line 913 of file IdentifierNamingCheck.cpp.

## ◆ expandMacro()

void clang::tidy::readability::IdentifierNamingCheck::expandMacro | ( | const Token & | MacroNameTok,
|  | const MacroInfo * | MI
| ) |  |

Add a usage of a macro if it already has a violation.

Definition at line 947 of file IdentifierNamingCheck.cpp.

References Name.

## ◆ onEndOfTranslationUnit()

void clang::tidy::readability::IdentifierNamingCheck::onEndOfTranslationUnit | ( |  | ) |
| override

Definition at line 960 of file IdentifierNamingCheck.cpp.

References Decl, clang::tidy::ClangTidyCheck::diag(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::FixStatus, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::Fixup, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::KindName, Loc, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::RawUsageLocs, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::ShouldFix(), and clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::ShouldNotify().

## ◆ registerMatchers()

void clang::tidy::readability::IdentifierNamingCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 236 of file IdentifierNamingCheck.cpp.

## ◆ registerPPCallbacks()

void clang::tidy::readability::IdentifierNamingCheck::registerPPCallbacks | ( | const SourceManager & | SM,
|  | Preprocessor * | PP,
|  | Preprocessor * | ModuleExpanderPP
| ) |  |
| override virtual

Override this to register `PPCallbacks` in the preprocessor.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. include directives and macro definitions.

There are two Preprocessors to choose from that differ in how they handle modular #includes:

- PP is the real Preprocessor. It doesn't walk into modular #includes and thus doesn't generate PPCallbacks for their contents.
- ModuleExpanderPP preprocesses the whole translation unit in the non-modular mode, which allows it to generate PPCallbacks not only for the main file and textual headers, but also for all transitively included modular headers when the analysis runs with modules enabled. When modules are not enabled ModuleExpanderPP just points to the real preprocessor.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 262 of file IdentifierNamingCheck.cpp.

## ◆ storeOptions()

void clang::tidy::readability::IdentifierNamingCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 198 of file IdentifierNamingCheck.cpp.

The documentation for this class was generated from the following files:

- IdentifierNamingCheck.h
- IdentifierNamingCheck.cpp